<?php

/**
 * To find the selection of json template list
 */
$getPostMetaValues = get_post_meta( get_the_ID());
$json_template_list = $getPostMetaValues['_json_template_list'][0] ?? "";

/*
    2022029 - MCD
    OC Query Functions moved to separate php required files for Organization of additional queries
*/
require WP_PLUGIN_DIR.'/everyware-plugin-json-template/nav-site-builder/query_functions/returnArticleLists.php';
require WP_PLUGIN_DIR.'/everyware-plugin-json-template/nav-site-builder/query_functions/returnFullArticleLists.php';

$conceptJSONFilePath = get_theme_file_path('/nav-site-builder-json/' . $json_template_list.'.json');
$conceptJSON = file_get_contents($conceptJSONFilePath);

/* Replace dashes from url with spaces */
/* Change First letter in each word to upper case */
/* Replace Concept Name in JSON */
$conceptNameFilter = str_replace('-', ' ', $conceptNameFilter);
$conceptNameFilter = ucwords($conceptNameFilter);
$conceptJSON = str_replace('{queryparam-conceptname}', $conceptNameFilter, $conceptJSON);

/* Replace Page Num in JSON */
$conceptJSON = str_replace('{pagenum}', $pageNum, $conceptJSON);

/* Decode JSON File */
$conceptJSONArray = json_decode($conceptJSON, true);
/* Set pageheadline */
$pageHeadline = $conceptNameFilter;

/* Create/Set No Duplicates Article Array */
if (isset($GLOBALS['used_uuids'])) {
    $noDuplicatesArray = $GLOBALS['used_uuids'];
} else {
    $noDuplicatesArray = array();
}

$find_Concept_Specific_Settings = $conceptNameFilter;
foreach ($conceptJSONArray as $key => $value) {
    if ($key == $find_Concept_Specific_Settings) {
        if (isset($conceptJSONArray[$find_Concept_Specific_Settings]['pageheadline'])) {
            $pageHeadline = $conceptJSONArray[$find_Concept_Specific_Settings]['pageheadline'];
        }
        if (isset($conceptJSONArray[$find_Concept_Specific_Settings]['pageurl'])) {
            $pageUrl = $conceptJSONArray[$find_Concept_Specific_Settings]['pageurl'];
        }
        if (isset($conceptJSONArray[$find_Concept_Specific_Settings]['headlinetemplate'])) {
            $headlineTemplate = $conceptJSONArray[$find_Concept_Specific_Settings]['headlinetemplate'];
        }
        if (isset($conceptJSONArray[$find_Concept_Specific_Settings]['defaultimage'])) {
            $defaultImage = $conceptJSONArray[$find_Concept_Specific_Settings]['defaultimage'];
        }

        $leftListsArray = $conceptJSONArray[$find_Concept_Specific_Settings]['left-lists'];
        if (isset($conceptJSONArray[$find_Concept_Specific_Settings]['right-lists'])) {
            $rightListsArray = $conceptJSONArray[$find_Concept_Specific_Settings]['right-lists'];
        } else {
            $rightListsArray = $conceptJSONArray['section_default']['right-lists'];
        }

        if (isset($conceptJSONArray[$find_Concept_Specific_Settings]['split'])) {
            $customPageSplit = $conceptJSONArray[$find_Concept_Specific_Settings]['split'];
            $customPageSplit = explode(",", $customPageSplit);
            if (isset($customPageSplit[1])) {
                $leftSplit = $customPageSplit[0];
                $rightSplit = $customPageSplit[1];
                $leftWidth = "width:" . $leftSplit . "%;";
                $rightWidth = "width:" . $rightSplit . "%;";
            } else {
                $leftWidth = "width:100%;";
                $rightWidth = "display: none;";
            }
        } else {
            $defaultPageSplit = $conceptJSONArray['section_default']['split'];
            $defaultPageSplit = explode(",", $defaultPageSplit);
            if (isset($defaultPageSplit[1])) {
                $leftSplit = $defaultPageSplit[0];
                $rightSplit = $defaultPageSplit[1];
                $leftWidth = "width:" . $leftSplit . "%;";
                $rightWidth = "width:" . $rightSplit . "%;";
            } else {
                $leftWidth = "width:100%;";
                $rightWidth = "display: none;";
            }
        }
    }
}

if(!$pageHeadline && isset($conceptJSONArray['section_default']['pageheadline']))
{
    $pageHeadline = $conceptJSONArray['section_default']['pageheadline'];
}
if(!isset($pageUrl) && isset($conceptJSONArray['section_default']['pageurl']))
{
    $pageUrl = $conceptJSONArray['section_default']['pageurl'];
}
if(!isset($headlineTemplate) && isset($conceptJSONArray['section_default']['headlinetemplate']))
{
    $headlineTemplate = $conceptJSONArray['section_default']['headlinetemplate'];
}
if(!isset($defaultImage) && isset($conceptJSONArray['section_default']['defaultimage']))
{
    $defaultImage = $conceptJSONArray['section_default']['defaultimage'];
}


/*Build Lists Array using default name settings */
require WP_PLUGIN_DIR.'/everyware-plugin-json-template/nav-site-builder/default-name-settings.php';

/* Build Left Lists Array */
$leftListsCounter = 1;
foreach ($leftListsArray as $list) {
    ${'leftLists' . $leftListsCounter} = array();

    if(isset($list['sortorder']) && $list['sortorder']){
        $leftSortOrder = $list['sortorder'];
    } else {
        $leftSortOrder = "Pubdate";
    }

    if(isset($list['ascending']) && $list['ascending']){
        $leftAscending = $list['ascending'];
    } else {
        $leftAscending = "false";
    }

    /* Check for adspot type */
    if (isset($list['contenttypes']) and $list['contenttypes'] == 'adspot') {
        ${'leftLists' . $leftListsCounter}['contenttypes'] = $list['contenttypes'] ?? null;
        ${'leftLists' . $leftListsCounter}['template'] = $list['template'] ?? null;
        ${'leftLists' . $leftListsCounter}['adcode'] = $list['adcode'] ?? null;
    }elseif (isset($list['contenttypes']) and $list['contenttypes'] == 'adspot_image') {
        ${'leftLists' . $leftListsCounter}['contenttypes'] = $list['contenttypes'] ?? null;
        ${'leftLists' . $leftListsCounter}['template'] = $list['template'] ?? null;
        ${'leftLists' . $leftListsCounter}['ad_image_url'] = $list['ad_image_url'] ?? null;
    } elseif (isset($list['contenttypes']) and $list['contenttypes'] == 'List') {

        ${'leftLists' . $leftListsCounter}['headline'] = $list['headline'] ?? null;
        ${'leftLists' . $leftListsCounter}['ads'] = $list['ads'] ?? null;

        if (isset($list['pagenum'])) {
            ${'leftLists' . $leftListsCounter}['pagenum'] = $list['pagenum'];
        }
        if (isset($list['query']) && isset($list['count']) && isset($list['start'])) {
            if (isset($list['pagination']) && $list['pagination']) {
                $queryStart = $list['start'] + ($list['count'] * ($list['pagenum'] - 1));
            } else {
                $queryStart = $list['start'];
            }
            $query = returnFullArticleLists($list['query'], $list['count'], $queryStart, $list['contenttypes'], $leftSortOrder, $leftAscending);

            ${'leftLists' . $leftListsCounter}['articles'] = $query['articles'];
            ${'leftLists' . $leftListsCounter}['hits'] = $query['hits'];
            /* Add article uuid to noDuplicatesArray */
            foreach (${'leftLists' . $leftListsCounter}['articles'] as $article) {
                array_push($noDuplicatesArray, $article['uuid']);
            }
        } else {
            ${'leftLists' . $leftListsCounter}['articles'] = null;
        }
    } else {
        ${'leftLists' . $leftListsCounter}['headline'] = $list['headline'] ?? null;
        ${'leftLists' . $leftListsCounter}['ads'] = $list['ads'] ?? null;

        if (isset($list['pagenum'])) {
            ${'leftLists' . $leftListsCounter}['pagenum'] = $list['pagenum'];
        }
        if (isset($list['query']) && isset($list['count']) && isset($list['start'])) {
            if (isset($list['pagination']) && $list['pagination']) {
                $queryStart = $list['start'] + ($list['count'] * ($list['pagenum'] - 1));
            } else {
                $queryStart = $list['start'];
            }
            $query = returnArticleLists($list['query'], $list['count'], $queryStart, $list['contenttypes'], $leftSortOrder, $leftAscending);
            ${'leftLists' . $leftListsCounter}['articles'] = $query['articles'];
            ${'leftLists' . $leftListsCounter}['hits'] = $query['hits'];
            /* Add article uuid to noDuplicatesArray */
            foreach (${'leftLists' . $leftListsCounter}['articles'] as $article) {
                array_push($noDuplicatesArray, $article['uuid']);
            }
        } else {
            ${'leftLists' . $leftListsCounter}['articles'] = null;
        }
    }
    ${'leftLists' . $leftListsCounter}['template'] = $list['template'] ?? null;
    $leftListsCounter++;
}

/* Build Right Lists Array */
if (isset($rightListsArray)) {
    $rightListsCounter = 1;
    foreach ($rightListsArray as $list) {
        ${'rightLists' . $rightListsCounter} = array();

        if(isset($list['sortorder']) && $list['sortorder']){
            $rightSortOrder = $list['sortorder'];
        } else {
            $rightSortOrder = "Pubdate";
        }
    
        if(isset($list['ascending']) && $list['ascending']){
            $rightAscending = $list['ascending'];
        } else {
            $rightAscending = "false";
        }

        /* Check for adspot type */
        if (isset($list['contenttypes']) and $list['contenttypes'] == 'adspot') {
            ${'rightLists' . $rightListsCounter}['contenttypes'] = $list['contenttypes'] ?? null;
            ${'rightLists' . $rightListsCounter}['template'] = $list['template'] ?? null;
            ${'rightLists' . $rightListsCounter}['adcode'] = $list['adcode'] ?? null;
            /* Check for column type */
        }elseif (isset($list['contenttypes']) and $list['contenttypes'] == 'adspot_image') {
            ${'rightLists' . $rightListsCounter}['contenttypes'] = $list['contenttypes'] ?? null;
            ${'rightLists' . $rightListsCounter}['template'] = $list['template'] ?? null;
            ${'rightLists' . $rightListsCounter}['ad_image_url'] = $list['ad_image_url'] ?? null;
        }  elseif (isset($list['contenttypes']) and $list['contenttypes'] == 'List') {
            ${'rightLists' . $rightListsCounter}['headline'] = $list['headline'] ?? null;
            ${'rightLists' . $rightListsCounter}['ads'] = $list['ads'] ?? null;
            
            if (isset($list['query']) && isset($list['count']) && isset($list['start'])) {
                ${'rightLists' . $rightListsCounter}['articles'] = returnFullArticleLists($list['query'], $list['count'], $list['start'], $list['contenttypes'], $rightSortOrder, $rightAscending)['articles'];
                /* Add article uuid to noDuplicatesArray */
                foreach (${'rightLists' . $rightListsCounter}['articles'] as $article) {
                    array_push($noDuplicatesArray, $article['uuid']);
                }
            }  else {
                ${'rightLists' . $rightListsCounter}['articles'] = null;
            }


        } else {
            ${'rightLists' . $rightListsCounter}['headline'] = $list['headline'] ?? null;
            ${'rightLists' . $rightListsCounter}['ads'] = $list['ads'] ?? null;
            

            if (isset($list['query']) && isset($list['count']) && isset($list['start'])) {
                ${'rightLists' . $rightListsCounter}['articles'] = returnArticleLists($list['query'], $list['count'], $list['start'], $list['contenttypes'], $rightSortOrder, $rightAscending)['articles'];
                /* Add article uuid to noDuplicatesArray */
                foreach (${'rightLists' . $rightListsCounter}['articles'] as $article) {
                    array_push($noDuplicatesArray, $article['uuid']);
                }
            }  else {
                ${'rightLists' . $rightListsCounter}['articles'] = null;
            }


        }
        ${'rightLists' . $rightListsCounter}['template'] = $list['template'] ?? null;
        $rightListsCounter++;
    }
}

